
/* GTK */
#include <glib.h>
#include <glib/gprintf.h>
#include <gtk/gtk.h>

#include <string.h>
#include <math.h>
#include <stdio.h>

#include "unicode_names.h"
#include "unicode_tools.c"


void dump_utf8_string (gchar *str) {
  gchar *s=str, *chs;
  gunichar ch;

  if (s && strlen(s)) while (ch=g_utf8_get_char_validated(s, -1)) {
    chs=g_malloc0(8);
    g_unichar_to_utf8(ch, chs);
    printf ("\"%s\"\t&#%d;\tU+%04X\t%s\n", chs, ch, ch, name_for_codepoint(ch));
    s=g_utf8_next_char(s);
  }
}

// clipboard
gchar *get_selection () {
  GtkClipboard *clip;
  clip=gtk_clipboard_get (GDK_SELECTION_PRIMARY);
  return gtk_clipboard_wait_for_text(clip); 
}


int main (int argc, char **argv) {

  gchar *sel;

  g_type_init ();
  gtk_init(NULL, NULL);

  sel=get_selection();
//  printf ("SELECTION: <%s>\n", sel);
  dump_utf8_string(sel);  

  return 0; 
}

